
#define db .byte      ; TASM cross-assembler definitions
#define dw .word
#define ds .block
#define fill .fill
#define org .org
#define end .end
#define equ .equ

        org     $4009

;= System variables ============================================

        db      0               ;VERSN
        dw      0               ;E_PPC
        dw      dfile           ;D_FILE
        dw      dfile+1         ;DF_CC
        dw      var             ;VARS
        dw      0               ;DEST
        dw      var+1           ;E_LINE
        dw      last-1          ;CH_ADD
        dw      0               ;X_PTR
        dw      last            ;STKBOT
        dw      last            ;STKEND
        db      0               ;BERG
        dw      membot          ;MEM
        db      0               ;not used
        db      2               ;DF_SZ
        dw      1               ;S_TOP
        db      $FF,$FF,$FF     ;LAST_K
        db      55              ;MARGIN
        dw      dfile           ;NXTLIN
        dw      0               ;OLDPPC
        db      0               ;FLAGX
        dw      0               ;STRLEN
        dw      $0C8D           ;T_ADDR
        dw      0               ;SEED
        dw      $FFFF           ;FRAMES
        db      0,0             ;COORDS
        db      $BC             ;PR_CC
        db      33,24           ;S_POSN
        db      01000000B       ;CDFLAG
        ds      33              ;Print buffer
membot: ds      30              ;Calculators memory area
        ds      2               ;not used

;= First BASIC line, asm code ==================================

line0:  db      0,0
        dw      dfile-$-2
        db      $ea             ; REM

START:
	ld hl,DummyDfile	; Transfer the spectrum screen attributes to the Chroma
	set 7,h			; Color attribute area = (DummyDfile)+$8000
	push hl
	ex de,hl
	ld hl,ATTR
	ld a,24
AttrLine:
	ld bc,32
	ldir
	inc de
	dec a
	jr nz,AttrLine
 
; Now, convert the speccy attr color to the zeddy chroma attr color
	pop hl
	ld c,24
nxtattrline:
	ld b,32
nxtattr:
	ld a,(hl)
	or a
	jr z,donothing
	push af
	and $07			; mask ink color
	ld e,a
	pop af
	push af
	and $38			; mask paper color
	rlca
	or e
	ld e,a
	pop af
	and $40			; mask bright bit
	push af
	rlca			; paper bright
	or e
	ld e,a
	pop af
	rrca			; ink bright
	rrca
	rrca
	or e
	ld (hl),a
donothing:
	inc hl
	djnz nxtattr
	dec c
	inc hl
	jr nz,nxtattrline

	ld a,$30		; set the attribute color mode
	ld bc,$7fef
	out (c),a

; ##############################################################
; #             HR Driver from Sponzy, by zsolt.               #
; # This driver simulate in ZX81 the ZX Spectrum Screen format #
; ##############################################################

HRON
	ld   a,(4028h)  ;+37h  ;\
	neg             ;-37h  ; number blank lines (55 or 31) system variable MARGIN
	inc  a          ;-36h  ; (negated as at BIOS:029Eh)
	ld   (neg_margin),a    ;/
	LD IX,HRDRV
forever:
	jp forever

SAVE_SP dw 0
VFRAME  dw 0
neg_margin db 

HRDRV
        LD A,R      	;delay  [9]
	LD B,$05	;delay  [7]
DLY	DJNZ DLY	;delay  [13/8]

	LD (SAVE_SP),SP		; 4	! 20	! SAVE SP.
	LD SP,NMISTACK		; 3	! 10	! because of nonlinear HFILE 

	POP HL			; 1	! 10	! 1st ROWADDRESS FROM NMISTACK
	POP IX			; 2	! 14	! "ld ix,DFILE"

	RET			; 1	! 10	! jump to DF_EXEC via NMISTACK

; -------------------------------------------------------
;	End of displaytask: 
DF_EXIT
	LD SP,(SAVE_SP)		 ; 4	! 20	! restore SP

	ld hl,(VFRAME)
	inc hl
	ld (VFRAME),hl
 ld   ix,retrace      ;-save the video vector so that NMI returns to PART 2
 ld   a,(neg_margin)    ;\
 ex   af,af'            ; init lower-border counter, and enable NMI generator
 out  (0feh),a          ;/
 jr   reti
;------------------
retrace:
 in   a,(0feh)          ;\start vertical retrace, and wait
 ld   b,1250/13         ; (1250 clks = 0.384ms = as by original zx81 bios)
 djnz $                 ;/
 ld   ix,HRDRV          ;-save the video vector so that NMI returns to PART 1
 ld   a,(neg_margin)    ;\init upper-border counter,
 ex   af,af'            ; terminate vertical retrace,
 out  (0feh),a          ;/and enable NMI generator
;out  (0ffh),a          ;-terminate vertical retrace (already done by out [FEh])
reti:
 pop  hl
 pop  de
 pop  bc
 pop  af
 ret
;---

;	
; ------------------------------------------------------------------------------ 
;	Executing D-File cont. (from NMISTACK)
; ------------------------------------------------------------------------------ 
DF_0100
	and (hl)		; 1     ! 7     ! delay
	and (hl)		; 1     ! 7     ! delay
	ld bc,$0100		; 3	! 10	! an offset value for computing
	add hl,bc		; 1	! 11	! address of the next row
DF_EXEC
	LD A,H			; 1	! 4	! high byte of rowaddr.
	LD I,A			; 2	! 9	! to "I" reg.
	LD A,L			; 1	! 4	! low byte of rowaddr.
	LD R,A			; 2	! 9	! to "R" reg.
	JP (IX)			; 2	! 8	! execute DFILE echo
;	32x NOP			; 32	! 128	!
;	RET (from DFILE)	; 1	! 10	! => "RET" to DF_xxxx
				;	!	! or "RET" to DF_EXIT
;
; ----------------------- 
DF_00A0
	ld bc,$00a0		; 3	! 10	! an offset value...
	add hl,bc		; 1	! 11	! address of the next row
	pop ix			; 2	! 14	! "ld ix,DF_LINxx"
	LD A,H			; 1	! 4	! high byte of rowaddr.
	LD I,A			; 2	! 9	! to "I" reg.
	LD A,L			; 1	! 4	! low byte of rowaddr.
	LD R,A			; 2	! 9	! to "R" reg.
	JP (IX)			; 2	! 8	! execute DFILE echo
;
; ----------------------- 
DF_F8A0
	ld bc,$f8a0	; 3	! 10	! 164	! an offset value...
	add hl,bc		; 1	! 11	! address of the next row
	pop ix			; 2	! 14	! "ld ix,DF_LINxx"
	LD A,H			; 1	! 4	! high byte of rowaddr.
	LD I,A			; 2	! 9	! to "I" reg.
	LD A,L			; 1	! 4	! low byte of rowaddr.
	LD R,A			; 2	! 9	! to "R" reg.
	JP (IX)			; 2	! 8	! execute DFILE echo;
; ----------------------- 
DF_F920
	ld bc,$f920	; 3	! 10	! 164	! an offset value...
	add hl,bc		; 1	! 11	! address of the next row
	pop ix			; 2	! 14	! "ld ix,DF_LINxx"
	LD A,H			; 1	! 4	! high byte of rowaddr.
	LD I,A			; 2	! 9	! to "I" reg.
	LD A,L			; 1	! 4	! low byte of rowaddr.
	LD R,A			; 2	! 9	! to "R" reg.
	JP (IX)			; 2	! 8	! execute DFILE echo
;
; ----------------------- 
DF_F9A0
	ld bc,$f9a0	; 3	! 10	! 164	! an offset value...
	add hl,bc		; 1	! 11	! address of the next row
	pop ix			; 2	! 14	! "ld ix,DF_LINxx"
	LD A,H			; 1	! 4	! high byte of rowaddr.
	LD I,A			; 2	! 9	! to "I" reg.
	LD A,L			; 1	! 4	! low byte of rowaddr.
	LD R,A			; 2	! 9	! to "R" reg.
	JP (IX)			; 2	! 8	! execute DFILE echo
;
; ------------------------------------------------------------------------------ 
;
NMISTACK
	dw HRSCREEN+$7E		; the addr. of scanline 1 - corrected for 'JP (IX)'
				; because the refresh register (R) increments by 2,
				; but the 7th bit of 'R' not changes!!!
	dw DF_LIN00+$8000	; this becomes to 'IX' (for jump to D-FILE execution)
	dw DF_EXEC		; the entry point of the display generator
	;
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F8A0,DF_LIN01+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN02+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN03+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F9A0,DF_LIN04+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F8A0,DF_LIN05+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN06+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN07+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_00A0,DF_LIN08+$8000

	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F8A0,DF_LIN09+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN10+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN11+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F9A0,DF_LIN12+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F8A0,DF_LIN13+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN14+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN15+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_00A0,DF_LIN16+$8000

	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F8A0,DF_LIN17+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN18+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN19+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F9A0,DF_LIN20+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F8A0,DF_LIN21+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN22+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_F920,DF_LIN23+$8000
	dw DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_0100,DF_EXIT

DummyDfile:
DF_LIN00 fill 32,$00 \ db $c9
DF_LIN01 fill 32,$00 \ db $c9
DF_LIN02 fill 32,$00 \ db $c9
DF_LIN03 fill 32,$00 \ db $c9
DF_LIN04 fill 32,$00 \ db $c9
DF_LIN05 fill 32,$00 \ db $c9
DF_LIN06 fill 32,$00 \ db $c9
DF_LIN07 fill 32,$00 \ db $c9

DF_LIN08 fill 32,$00 \ db $c9
DF_LIN09 fill 32,$00 \ db $c9
DF_LIN10 fill 32,$00 \ db $c9
DF_LIN11 fill 32,$00 \ db $c9
DF_LIN12 fill 32,$00 \ db $c9
DF_LIN13 fill 32,$00 \ db $c9
DF_LIN14 fill 32,$00 \ db $c9
DF_LIN15 fill 32,$00 \ db $c9

DF_LIN16 fill 32,$00 \ db $c9
DF_LIN17 fill 32,$00 \ db $c9
DF_LIN18 fill 32,$00 \ db $c9
DF_LIN19 fill 32,$00 \ db $c9
DF_LIN20 fill 32,$00 \ db $c9
DF_LIN21 fill 32,$00 \ db $c9
DF_LIN22 fill 32,$00 \ db $c9
DF_LIN23 fill 32,$00 \ db $c9

	ds $100-($%$100)	; HR screen address should be at a 256 bytes boundary

HRSCREEN:		; The ZX Spectrum .scr file should be inserted here
	ds $1800

ATTR:   ds $300

        db      $76             ;N/L

;- Display file --------------------------------------------

dfile:  db      $76
        db      $76,$76,$76,$76,$76,$76,$76,$76
        db      $76,$76,$76,$76,$76,$76,$76,$76
        db      $76,$76,$76,$76,$76,$76,$76,$76

;- BASIC-Variables ----------------------------------------

var:    db      $80

;- End of program area ----------------------------

last:

        end
